SystemOrganization addCategory: #'NativeBoost-Tests'!

NBExternalStructure variableByteSubclass: #NBTestNestedStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBTestNestedStructure class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/26/2012 19:45'!
fieldsDesc
" self createAccessors "
	^ #(
	
		NBTestStructure1byte oneByte;
		int otherField
		)! !

NBExternalStructure variableByteSubclass: #NBTestStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBTestStructure class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/3/2012 01:44'!
fieldsDesc
" self rebuildFieldAccessors "
	^ #(
		byte byte;
		short short;
		long long;
		float float;
		double double;
		int64 int64;
		)! !

NBExternalStructure variableByteSubclass: #NBTestStructure1byte
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBTestStructure1byte class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/3/2012 02:36'!
fieldsDesc
" self rebuildFieldAccessors "
	^ #(
		byte field
		)! !

NBExternalStructure variableByteSubclass: #NBTestStructure2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBTestStructure2 class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/3/2012 02:36'!
fieldsDesc
" self rebuildFieldAccessors "
	^ #(
		NBExternalAddress addr
		)! !

NBExternalStructure variableByteSubclass: #NBTestStructure9bytes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBTestStructure9bytes class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/3/2012 02:36'!
fieldsDesc
" self rebuildFieldAccessors"
	^ #(
		int x;
		int y;
		char field
		)! !

NBExternalStructure variableByteSubclass: #NBTestStructureWithCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBTestStructureWithCallback class methodsFor: 'as yet unclassified' stamp: 'cipt 11/28/2012 19:10'!
fieldsDesc
" self rebuildFieldAccessors "
	^ #(
		int x;
		NBQSortCallback callback;
		int y;
		)! !

TestCase subclass: #NBExternalAddressTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBExternalAddressTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/4/2011 08:25'!
testAddressAndStruct

	| struct addr string |
	
	struct := NBTestStructure2 new.
	
	self assert: struct addr class == NBExternalAddress .  
	
	addr := NativeBoost allocate: 10.
	[
		addr writeString: 'abcde'.

		struct addr: addr.
		
		self assert: addr = struct addr.

		string := struct addr readString .		
	] ensure: [ NativeBoost free: addr ].

	self assert: string = 'abcde'
! !

!NBExternalAddressTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 22:51'!
testMemoryAccess

	| addr |
	
	addr := NativeBoost allocate: 10.
	[
		1 to: 10 do: [:i |
			addr byteAt: i-1 put: i ].
	
		1 to: 10 do: [:i |
			self assert: (addr byteAt: i-1) = i ].
	] ensure: [ NativeBoost free: addr ]
! !

!NBExternalAddressTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/4/2011 07:29'!
testStringAccess

	| addr string |
	
	addr := NativeBoost allocate: 10.
	[
		addr writeString: 'abcde'.
		string := addr readString. 

	] ensure: [ NativeBoost free: addr ].

	self assert: string = 'abcde'
! !

!NBExternalAddressTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/4/2011 08:50'!
testStructCopy

	| struct addr string struct2 |
	
	struct := NBTestStructure new.
	
	struct byte: 5;
		long: 10;
		short: 20.
		
	addr := NativeBoost allocate: NBTestStructure instanceSize.
	
	NativeBoost memCopy: struct to: addr size:  NBTestStructure instanceSize.
	struct2 := NBTestStructure fromPointer: addr.
	NativeBoost free: addr.
		  

	self assert: struct2 byte = 5.
	self assert: struct2 long = 10.
	self assert: struct2 short = 20.! !

TestCase subclass: #NBExternalHeapManagerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBExternalHeapManagerTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/5/2011 07:20'!
newHeap
	^  NBMockExternalHeapManager new! !

!NBExternalHeapManagerTests methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/5/2010 20:47'!
testAllocate
	" 
		self new testAllocate 
	
	"
	| heap address size |
	
	size := 100.
	heap := self newHeap.
	
	address := heap allocate: size.
	
	self assert:  ( heap isValidAddress: address size: size ) .
	self assert:   heap totalAllocatedMemory = size.
	self assert:   heap numPages = 1 .
	self assert:  heap numAllocatedBlocks = 1.

	heap free: address.

	self assert: heap numAllocatedBlocks = 0.
	self assert: heap numPages = 0 .
	self assert: heap numBlocks = 0 .
	self assert:  (heap isValidAddress: address size: size) not .
	
	self assert: heap totalAllocatedMemory = 0.
	
	
	! !

!NBExternalHeapManagerTests methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/5/2010 20:45'!
testAllocate2
	" 
		self new testAllocate2 
	
	"
	| heap addr1 addr2 |
	
	heap := self newHeap.

	addr1 := heap allocate: 1.
	addr2 := heap allocate: 2.
	
	self assert:  heap totalAllocatedMemory = 3 .
	self assert:  heap numAllocatedBlocks = 2 .

	heap free: addr1.

	self assert:  heap numAllocatedBlocks = 1.
	self assert:  heap totalAllocatedMemory = 2 .

	heap free: addr2.
	
	self assert:  heap numPages = 0 .
	self assert: heap numBlocks = 0 .
	self assert:  heap totalAllocatedMemory = 0 .
	
	
	
! !

TestCase subclass: #NBFFICalloutIndirectArgumentTests
	instanceVariableNames: 'testIvar'
	classVariableNames: 'CLASSVAR TYPEVAR'
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBFFICalloutIndirectArgumentTests methodsFor: 'error messages' stamp: 'cipt 10/26/2012 21:05'!
boundsError
	^'Bound checking failed on indirect argument loading'! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'nativeboost-primitives' stamp: 'IgorStasenko 11/24/2012 17:11'!
primIsPointers: anObject
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCallout function: #(NBBool (oop anObject)) 
		emit: [ :gen :proxy :asm | 
			asm pop: asm EAX. 
			proxy isPointers:  asm EAX 
		]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'nativeboost-primitives' stamp: 'IgorStasenko 11/24/2012 17:12'!
returnOop1Of: anArg 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout 
		options: #( + optUseStackPointer optNoAlignment +optCheckIndirectArgBounds - optDirectProxyFnAddress );
		
		function: #( oop (oop anArg@1) ) emit: [:gen |
		gen asm mov: gen asm ESP ptr to: gen asm EAX ]
	! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'nativeboost-primitives' stamp: 'IgorStasenko 11/24/2012 17:13'!
returnOop2Of: anArg 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout
		options: #( + optUseStackPointer optNoAlignment +optCheckIndirectArgBounds - optDirectProxyFnAddress );

		 function: #( oop (oop anArg@2) ) emit: [:gen |
			gen asm mov: gen asm ESP ptr to: gen asm EAX ]
	! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'nativeboost-primitives' stamp: 'IgorStasenko 11/24/2012 17:13'!
returnOop5Of: anArg 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout 
		options: #( + optUseStackPointer optNoAlignment +optCheckIndirectArgBounds - optDirectProxyFnAddress );
	
		function: #( oop (oop anArg@5) ) emit: [:gen |
			gen asm mov: gen asm ESP ptr to: gen asm EAX ]
	! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'nativeboost-primitives' stamp: 'IgorStasenko 11/24/2012 17:14'!
returnOopMinus1Of: anArg 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout
		options: #( + optUseStackPointer optNoAlignment +optCheckIndirectArgBounds - optDirectProxyFnAddress );
		function: #( oop (oop anArg@ -1) ) emit: [:gen |
			gen asm mov: gen asm ESP ptr to: gen asm EAX ]
	! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'nativeboost-primitives' stamp: 'IgorStasenko 11/24/2012 17:15'!
returnOopMinus3Of: anArg 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout 
		options: #( + optUseStackPointer optNoAlignment +optCheckIndirectArgBounds - optDirectProxyFnAddress );
		function: #( oop (oop anArg@ -3) ) emit: [:gen |
			gen asm mov: gen asm ESP ptr to: gen asm EAX ]
	! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/27/2012 12:23'!
testIndirectArgumentArrayNegativeIndirect
	| array |
	array := {1.
	2.
	3.
	4.
	5}.
	self should: [(self returnOopMinus1Of: array)] raise: NBFFICalloutError  withExceptionDo: [:anEx | self assert: anEx messageText = self boundsError ].
	self should: [(self returnOopMinus3Of: array)] raise: NBFFICalloutError  withExceptionDo: [:anEx | self assert: anEx messageText = self boundsError ].
! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 20:43'!
testIndirectArgumentArrayOk
	| array |
	array := {1.
	2.
	3.
	4.
	5}.
	self assert: (self returnOop1Of: array) == 1.
	self assert: (self returnOop2Of: array) == 2.
	self assert: (self returnOop5Of: array) == 5! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/27/2012 12:21'!
testIndirectArgumentDictionayFailure
	| array |
	array := {(1 -> 2).
	(3 -> 3)} asDictionary.
	self assert: (self returnOop1Of: array) =  2. "tally"
	self assert: (self returnOop2Of: array) = {nil. 1->2. nil. 3->3. nil}. "array"
	self
		should: [ self returnOop5Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self boundsError ]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 21:08'!
testIndirectArgumentFloatFailure
	| array |
	array := 2.0.
	self
		should: [ self returnOop1Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ].
	self
		should: [ self returnOop2Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ].
	self
		should: [ self returnOop5Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/27/2012 12:16'!
testIndirectArgumentLargePositiveIntegerFailure
	| array |
	array := 100 factorial.
	self
		should: [ self returnOop1Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ].
	self
		should: [ self returnOop2Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ].
	self
		should: [ self returnOop5Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 21:08'!
testIndirectArgumentObjectBoundsFailure
	| array |
	array := Object new.
	self
		should: [ self returnOop2Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self boundsError ].
	self
		should: [ self returnOop5Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self boundsError ]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 20:53'!
testIndirectArgumentObjectFirstBoundsFailure
	| array |
	array := Object new.
	self should: [ self returnOop1Of: array ] raise: NBFFICalloutError.
! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 21:08'!
testIndirectArgumentPointFailure
	| array |
	array := 2 @ 5.
	self assert: (self returnOop1Of: array) == 2.
	self assert: (self returnOop2Of: array) == 5.
	self
		should: [ self returnOop5Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self boundsError ]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 21:08'!
testIndirectArgumentSmallIntegerFailure
	| array |
	array := 2.
	self
		should: [ self returnOop1Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ].
	self
		should: [ self returnOop2Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError ].
	self
		should: [ self returnOop5Of: array ]
		raise: NBFFICalloutError
		withExceptionDo: [ :anEx | self assert: anEx messageText = self typeError  ]! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/27/2012 12:41'!
testIndirectableObjects
	|ok |
	ok := {
	Object new.
	{1. 2}.
	{1->2. 2->3} asDictionary.
	2@3.
	}.
	ok do:[:each | self assert: (self primIsPointers: each)].! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'tests' stamp: 'cipt 10/27/2012 12:43'!
testNotIndirectableObjects
	|ok |
	ok := {
	2. "small integer"
	100 factorial. "large positive integer"
	3.4. "float"
	'abcd'. "bytestring"
	'abcd' asByteArray. "bytearray"
	}.
	ok do:[:each | self deny: (self primIsPointers: each)].! !

!NBFFICalloutIndirectArgumentTests methodsFor: 'error messages' stamp: 'cipt 10/26/2012 21:04'!
typeError
	^'Type checking failed on indirect argument loading'! !

TestCase subclass: #NBFFICalloutTests
	instanceVariableNames: 'testIvar'
	classVariableNames: 'CLASSVAR TYPEVAR'
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBFFICalloutTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:15'!
arraySize2: array with: param2
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		function: #(ulong (NBByteArraySize array, long param2))
		emit: [:gen |
			"pop the array size"
			gen asm pop: gen asm EAX
		]
! !

!NBFFICalloutTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:15'!
arraySize: array
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #(ulong (NBByteArraySize array))
		emit: [:gen |
			"pop the array size"
			gen asm pop: gen asm EAX
		]
! !

!NBFFICalloutTests methodsFor: 'generator callbacks' stamp: 'IgorStasenko 9/3/2012 00:12'!
asNBExternalType: gen

	self assert: (gen respondsTo: #asm).
	self assert: (gen respondsTo: #proxy).
	
	self assert: (gen requestor == self).

	
	^ NBUInt32 new! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'Igor.Stasenko 4/30/2010 12:02'!
checkType: type class: typeClass arity: ptrArity stackIndex: stackIndex

	self assert: type class == typeClass.
	self assert: type pointerArity = ptrArity.
	self assert: type loader class == NBSTMethodArgument.
	self assert: type loader stackIndex = stackIndex ! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'cipt 10/26/2012 19:32'!
checkType: type class: typeClass arity: ptrArity stackIndex: stackIndex elementIndex: anIndex

	self assert: type class == typeClass.
	self assert: type pointerArity = ptrArity.
	self assert: type loader class == NBSTIndirectArgument.
	self assert: type loader argumentLoader stackIndex = stackIndex. 
	self assert: type loader elementIndex = anIndex  
	! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'Igor.Stasenko 4/30/2010 12:03'!
checkType: type class: typeClass value: const
	self assert: type class == typeClass.
	self assert: type value = const! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'IgorStasenko 11/24/2012 17:15'!
nativeFailWithCode: aCode

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #(void (uint aCode) ) emit: [:gen :proxy :asm |
			asm pop: asm EAX.
			gen failWithCode: asm EAX.
		]
! !

!NBFFICalloutTests methodsFor: 'generator callbacks' stamp: 'IgorStasenko 3/27/2012 18:19'!
nbBindingOf: aName

	^ self class bindingOf: aName! !

!NBFFICalloutTests methodsFor: 'generator callbacks' stamp: 'IgorStasenko 2/24/2012 17:53'!
nbFnArgument: argName generator: gen

	self assert: argName = 'testIvar'.
	^ 'testIvar loader'! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'IgorStasenko 11/24/2012 17:16'!
returnParamUsingStackPtr: aParam

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout 
		options: #( + optUseStackPointer optNoAlignment - optDirectProxyFnAddress );
		function: #( oop (oop aParam) ) emit: [:gen |
			gen asm mov: gen asm ESP ptr to: gen asm EAX ]
	! !

!NBFFICalloutTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:16'!
returnReceiver: x arg2: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	

	^ self nbCallout
		function: #( oop (oop self , oop x, oop y)) emit: [
		:gen :proxy :asm |
			proxy receiver
		] ! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'Igor.Stasenko 5/3/2010 23:31'!
testArraySize

	| arr |
	
	arr := ByteArray new: 100.

	self assert: (self arraySize: arr) = 100.

	self assert: (self arraySize2: arr with: 20) = 100.! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'IgorStasenko 9/3/2012 00:03'!
testBuildingFnSpec

	| generator type s |
	generator := NBFFICallout new.
	
	CLASSVAR := 100.
	TYPEVAR := 'long'.
	
	generator
		requestor: self;
		methodArgs: #( 'arg1' 'arg2' 'arg3' );
		cdecl;
		anonSpec: #( long* (int self ,  String arg1, void**arg2, TYPEVAR arg1, char arg3, 0, nil, true, false , CLASSVAR ) ).


	type := generator fnSpec returnType.
	self assert: (type class == NBInt32).	
	self assert: (type pointerArity = 1).
	
	self assert: (generator fnSpec arguments size = 10).
	s := generator fnSpec arguments readStream.
"int self"		self checkType: s next class:  NBInt32 arity: 0 stackIndex: 3 .
"String arg1"	self checkType: s next class: NBExternalString arity: 0 stackIndex: 2 .
"void**arg2"	self checkType: s next class: NBVoid arity: 2 stackIndex: 1.
"TYPEVAR arg1"	self checkType: s next class:  NBInt32 arity: 0 stackIndex: 2.
"char arg3"		self checkType: s next class: NBCharacterType arity: 0 stackIndex: 0.
"0"				self checkType: s next class: NBFFIConst value: 0.
"nil"				self checkType: s next class: NBFFIConst value: 0.
"true"			self checkType: s next class: NBFFIConst value: 1.
"false"			self checkType: s next class: NBFFIConst value: 0.
"CLASSVAR"	self checkType: s next class: NBFFIConst value: 100.

! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'cipt 10/24/2012 19:32'!
testBuildingFnSpecWithQueries

	| generator type s |
	generator := NBFFICallout new.
	
	CLASSVAR := 100.
	TYPEVAR := 'long'.
	
	generator
		requestor: self;
		methodArgs: #( 'arg1' 'arg2' 'arg3' );
		cdecl;
		anonSpec: #( long* (int self , int arg3@2,  String arg1, void**arg2, TYPEVAR arg1, long **arg1@1, char arg3, 0, nil, true, false , CLASSVAR ) ).


	type := generator fnSpec returnType.
	self assert: (type class == NBInt32).	
	self assert: (type pointerArity = 1).
	
	self assert: (generator fnSpec arguments size = 12).
	s := generator fnSpec arguments readStream.
"int self"		self checkType: s next class:  NBInt32 arity: 0 stackIndex: 3 .
"int arg3@2"    self checkType: s next class: NBInt32 arity: 0 stackIndex: 0 elementIndex: 2.
"String arg1"	self checkType: s next class: NBExternalString arity: 0 stackIndex: 2 .
"void**arg2"	self checkType: s next class: NBVoid arity: 2 stackIndex: 1.
"TYPEVAR arg1"	self checkType: s next class:  NBInt32 arity: 0 stackIndex: 2.
"long ** arg1@1"    self checkType: s next class: NBInt32 arity: 2 stackIndex: 2 elementIndex: 1.
"char arg3"		self checkType: s next class: NBCharacterType arity: 0 stackIndex: 0.
"0"				self checkType: s next class: NBFFIConst value: 0.
"nil"				self checkType: s next class: NBFFIConst value: 0.
"true"			self checkType: s next class: NBFFIConst value: 1.
"false"			self checkType: s next class: NBFFIConst value: 0.
"CLASSVAR"	self checkType: s next class: NBFFIConst value: 100.

! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2011 18:36'!
testFailCode

	self assert: 
	(	
		[ self nativeFailWithCode: 1234. false ] on: NBNativeCodeError do: [:ex |
			ex return: ex errorCode = 1234 ]
	)
	! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'IgorStasenko 8/10/2011 18:27'!
testProxyReceiver

	
	self assert: 
		(self returnReceiver: 10 arg2: 20) == self! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'IgorStasenko 9/3/2012 00:12'!
testSupportedProtocols

	| gen spec arg | 
	gen := NBFFICallout new requestor: self.
	CLASSVAR := self. "so we will receive #asNBExternalType: "
	gen anonSpec: #(CLASSVAR (CLASSVAR testIvar)).
	
	spec := gen fnSpec.
	
	self assert: spec returnType class == NBUInt32.
	
	arg := spec arguments first.

	self assert: arg class == NBUInt32.
	self assert: arg loader ='testIvar loader'.
		! !

!NBFFICalloutTests methodsFor: 'tests' stamp: 'Igor.Stasenko 5/1/2010 12:02'!
testUseStackPointer


	self assert: (self returnParamUsingStackPtr: 100) = 100.
! !

TestCase subclass: #NBFFIExternalStructTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBFFIExternalStructTests class methodsFor: 'failures' stamp: 'MarcusDenker 2/20/2013 08:59'!
expectedFailures
	^Smalltalk os isWin32
		ifTrue: [#(testReturnStructWithCallback)] 
		ifFalse: [#()]! !

!NBFFIExternalStructTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:17'!
returnStruct1Byte
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		function: #(NBTestStructure1byte () ) 
		emit: [:gen :proxy :asm |
			asm mov: 42 to: asm EAX
		]
	! !

!NBFFIExternalStructTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:18'!
returnStruct9Bytes
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #(NBTestStructure9bytes () ) 
		emit: [:gen :proxy :asm |
		
			asm 
				mov: asm ESP ptr to: asm EAX;
		"fill struct with 1, 2, 3 values"
				mov: 1 to: asm EAX ptr;
				mov: 2 to: asm EAX ptr+4;
				mov: 3 to: asm EAX ptr+8
		]
	! !

!NBFFIExternalStructTests methodsFor: 'as yet unclassified' stamp: 'cipt 11/28/2012 19:29'!
returnStructWithCallback: aCallback
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #(NBTestStructureWithCallback (NBQSortCallback aCallback) ) 
		emit: [:gen :proxy :asm |
		
			asm
				"mov: asm ESP ptr to: asm EAX;"
				pop: asm EAX;
				pop: asm EDX;
		"fill struct with 1, 2, 3 values"
				mov: 1 to: asm EAX ptr;
				mov: asm EDX to: asm EAX ptr+4;
				mov: 3 to: asm EAX ptr+8;
				push: asm EAX
		 ]
	! !

!NBFFIExternalStructTests methodsFor: 'tests' stamp: 'IgorStasenko 9/3/2012 02:33'!
testNestedStructure

	| s1 s2 |
	
	NBTestStructure1byte rebuildFieldAccessors.
	NBTestNestedStructure rebuildFieldAccessors.
	s1 := NBTestNestedStructure new.
	s2 := NBTestStructure1byte new.
	s2 field: 42.
	
	self assert: s1 oneByte field = 0.
	
	s1 oneByte: s2.
	
	self assert: s1 oneByte field = 42.
	! !

!NBFFIExternalStructTests methodsFor: 'tests' stamp: 'IgorStasenko 9/3/2012 02:33'!
testReturnStruct1Byte

	| s |
	NBTestStructure1byte rebuildFieldAccessors.
	NBTestNestedStructure rebuildFieldAccessors.
	
	NBNativeCodeGen removeNativeCodeFrom: self class >> #returnStruct1Byte.
	
	s := self returnStruct1Byte.
	
	self assert: s field = 42.! !

!NBFFIExternalStructTests methodsFor: 'tests' stamp: 'cipt 11/28/2012 19:03'!
testReturnStruct9Bytes

	| s |
	
	NBTestStructure1byte rebuildFieldAccessors.
	NBTestNestedStructure rebuildFieldAccessors.
	NBTestStructure9bytes  rebuildFieldAccessors.
	
	NBNativeCodeGen removeNativeCodeFrom: self class >> #returnStruct9Bytes.

	s := self returnStruct9Bytes.
	
	self assert: s x = 1.
	self assert: s y = 2.
	self assert: s field asciiValue = 3.! !

!NBFFIExternalStructTests methodsFor: 'tests' stamp: 'cipt 11/28/2012 19:40'!
testReturnStructWithCallback

	| s callback|
	NBTestStructureWithCallback rebuildFieldAccessors.
	
	NBNativeCodeGen removeNativeCodeFrom: self class >> #returnStructWithCallback:.
	callback := NBQSortCallback on: [:a :b | a < b].
	s := self returnStructWithCallback: callback.
	
	self assert: s x = 1.
	self assert: s callback trunk  = callback trunk.
	self assert: s y = 3.! !

TestCase subclass: #NBFnSpecParserTest
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBFnSpecParserTest methodsFor: 'as yet unclassified' stamp: 'cipt 10/26/2012 19:19'!
argName: argName indirectIndex: anIndex type: typeName ptrArity: ptrArity

	^ #argument! !

!NBFnSpecParserTest methodsFor: 'callbacks' stamp: 'IgorStasenko 2/13/2012 13:03'!
integerConstantArgument: int

	^ #integerConstant! !

!NBFnSpecParserTest methodsFor: 'parser' stamp: 'IgorStasenko 2/13/2012 13:01'!
newParser
	^ NBFnSpecParser new! !

!NBFnSpecParserTest methodsFor: 'callbacks' stamp: 'IgorStasenko 2/13/2012 13:04'!
returnType: aType

	^ #returnType! !

!NBFnSpecParserTest methodsFor: 'tests' stamp: 'cipt 10/26/2012 19:30'!
testParseAnonFn

	 | parser args |
	
	#(
		#(int * * ( 0, nil, -10, FOO_BAR , int a, int* _b, char** c, void* * * d_))
		'int * * ( 0, nil, -10, FOO_BAR , int a, int* _b, char** c, void* * * d_)'  ) do: [:spec |
	
	
		parser := self newParser parseAnonFunction: spec.
		
		self assert: parser returnType = #('int' 2).
	
		args := parser arguments.
		self assert: args size = 8.

		self assert: (args at: 1) = 0. 
		self assert: (args at: 2) = #(nil nil 'nil' 0). 
		self assert: (args at: 3) = -10. 
		self assert: (args at: 4) = #(nil nil 'FOO_BAR' 0). 
		self assert: (args at: 5) = #('a' nil 'int' 0). 
		self assert: (args at: 6) = #('_b' nil 'int' 1). 
		self assert: (args at: 7) = #('c' nil 'char' 2). 
		self assert: (args at: 8) = #('d_' nil 'void' 3 ). 
	]! !

!NBFnSpecParserTest methodsFor: 'tests' stamp: 'cipt 10/26/2012 19:30'!
testParseNamedFn

	 | parser args |
	
	#(
	(int * * #'function_n$a$m$e' ( 0, nil, -10, FOO_BAR , int a, int* _b, char** c, void* * * d_))
	' int * * function_n$a$m$e (0, nil, -10, FOO_BAR , int a, int* _b, char** c, void* * * d_    ' ) do: [:spec |

		parser := self newParser parseNamedFunction: spec.
		
		self assert: parser functionName = 'function_n$a$m$e'.
		self assert: parser returnType = #('int' 2).
		
		args := parser arguments.
		self assert: args size = 8.

		self assert: (args at: 1) = 0. 
		self assert: (args at: 2) = #(nil nil 'nil' 0). 
		self assert: (args at: 3) = -10. 
		self assert: (args at: 4) = #(nil nil 'FOO_BAR' 0). 
		self assert: (args at: 5) = #('a' nil 'int' 0). 
		self assert: (args at: 6) = #('_b' nil 'int' 1). 
		self assert: (args at: 7) = #('c' nil 'char' 2). 
		self assert: (args at: 8) = #('d_' nil 'void' 3 ). 
	].
! !

!NBFnSpecParserTest methodsFor: 'tests' stamp: 'IgorStasenko 2/9/2012 12:44'!
testParseNoArgsFn

	 | parser args |
	#( 
	 #(int * * function_name ( void ) )
	' int * * function_name  ( void ) '
	) do: [:spec |
		parser := self newParser parseNamedFunction: spec.
		
		self assert: parser functionName = 'function_name'.
		self assert: parser returnType = #('int' 2).
	
		args := parser arguments.
		self assert: args size = 0.
	]! !

!NBFnSpecParserTest methodsFor: 'tests' stamp: 'IgorStasenko 2/13/2012 13:16'!
testParserCallbacks

	| parser  spec parsedSpec args | 
	parser := self newParser requestor: self.
	
	spec := #(int * * function_name ( 0, nil, -10, FOO_BAR , int a, int* _b, char** c, void* * * d_)).
	parsedSpec := parser parseNamedFunction: spec.
	
	self assert: parsedSpec returnType equals: #returnType.
	
	args := parsedSpec arguments.
	
	self assert: args first = #integerConstant.
	self assert: args third = #integerConstant.
	args := args reject: [:each | each = #integerConstant ].

	self assert: args size = 6.
	self assert: args asSet size = 1.
	self assert: args first = #argument! !

TestCase subclass: #NBInterpreterProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBInterpreterProxyTest class methodsFor: 'failures' stamp: 'MarcusDenker 2/20/2013 08:59'!
expectedFailures
			^Smalltalk os isWin32
				ifTrue: [#(testStackPointer testStackPointer2)] 
				ifFalse: [#()]! !

!NBInterpreterProxyTest methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:20'!
primCheckStackPointer
	"should answer 0"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCallout function: #(uint () ) emit: [:gen :proxy :asm | 
		| get |
		proxy getStackPointer.
		asm 
			mov: NBInterpreterProxy stackPointerAddress asUImm32 to: asm ECX;
		 	mov: asm ECX ptr to: asm ECX;
			sub: asm EAX with: asm ECX
	] ! !

!NBInterpreterProxyTest methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:21'!
primCheckStackPointer2
	"should answer 0"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCallout
		function: #(uint () ) 
		emit: [:gen :proxy :asm | 
			| get |
			proxy getStackPointer.
			asm 
				mov: NBInterpreterProxy stackPointerAddress asUImm32 ptr32 to: asm ECX;
				sub: asm EAX with: asm ECX
		] ! !

!NBInterpreterProxyTest methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 04:42'!
testStackPointer


	self assert: self primCheckStackPointer=0
	! !

!NBInterpreterProxyTest methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 05:22'!
testStackPointer2


	self assert: self primCheckStackPointer2=0
	! !

TestCase subclass: #NBWin32ShellTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBWin32ShellTest class methodsFor: 'testing' stamp: 'TorstenBergmann 12/20/2012 10:19'!
isAbstract
	"Should only run on Window"
	
	^OSPlatform isWin32 not
	! !

!NBWin32ShellTest methodsFor: 'testing' stamp: 'TorstenBergmann 12/20/2012 10:16'!
testGetEnvironmentVariable
	"PATH should be accessible on any windows system, so we can use it to test"
	
	self assert: (NBWin32Shell getEnvironmentVariable: 'PATH') notEmpty
	! !

TestCase subclass: #NBCoreTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Tests'!

!NBCoreTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/20/2012 12:01'!
nonExistedPrim: aBlock
	| a b c|
	<primitive: #abra module: #kadabra error: errorCode >
	

	^ aBlock value: thisContext	! !

!NBCoreTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/20/2012 14:08'!
return0Code
	" a simple routine, just return 1 (smallinteger = 0)"
	| asm |
	
	^ (asm :=  NativeBoost newAssembler )
		noStackFrame;
		mov: 1 to: asm EAX;
		ret;
		bytes
! !

!NBCoreTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/13/2012 13:25'!
stub
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ 100! !

!NBCoreTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/13/2012 13:42'!
stub2
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ NBNativeCodeGen generateCode: [:gen | 
			
			self return0Code
		
		] andRetry: thisContext! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 8/24/2012 17:19'!
testExternalResourceManagerFinalization

	
	| obj count |
	
	
	count := 0. 
	obj := NBMockExternalObject new.
	obj data: [ count := count + 1 ].
	
	
	obj registerAsExternalResource.
	obj := nil.
	Smalltalk garbageCollect; garbageCollect.
	
	self assert: (count = 1)! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 5/31/2012 14:53'!
testFinalization

	| reg objs count |
	
	reg := NBFinalizationRegistry new.
	count := 0.
	reg freeItemsDo: [:item | count := count + 1].
	
	self assert: count = reg initialSize.
	
	objs := OrderedCollection new.
	133 timesRepeat: [ reg add: (objs add: Object new) ].
	
	count := 0.
	reg freeItemsDo: [:item | count := count + 1].

	self assert: reg items size - count = 133.
	
	objs := nil.
	Smalltalk garbageCollect.
	
	count := 0.
	reg freeItemsDo: [:item | count := count + 1].
	
	self assert: count = reg items size.
	
	reg reset.
	count := 0.
	reg freeItemsDo: [:item | count := count + 1].
	
	self assert: count = reg initialSize.
! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 2/20/2012 14:26'!
testGenerateAndRetry

	NBNativeCodeGen removeNativeCodeFrom: (self class>>#stub2).
 	[
		self assert: self stub2 = 0.
	] ensure: [
		NBNativeCodeGen removeNativeCodeFrom: (self class>>#stub2).
	].	 
! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 2/20/2012 12:13'!
testGettingError

	self nonExistedPrim: [:context |

	"This error produced by Cog VM, when primitive not found"
		self assert: 
		(context tempAt: 	context method numTemps ) == #'not found'
	
	]! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 3/20/2011 04:12'!
testHasTrailerInstalled

	
	"Make sure compiled methods trailer installed"
	
	self assert: (CompiledMethodTrailer trailerKinds includes: #NativeCodeTrailer )! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 2/13/2012 14:04'!
testInstallingNativeCode
	"
	Test a protocol for installing/removing native code directly.
	"
	NBNativeCodeGen removeNativeCodeFrom: (self class>>#stub).
	self assert: (self class>>#stub) hasNativeCode not.
	
	self assert: self stub = 100.
	
	 [
		NBNativeCodeGen installNativeCode: self return0Code into: (self class>>#stub).
		self assert: (self class>>#stub) hasNativeCode.

		self assert: (self stub = 0).
	] ensure: [
		NBNativeCodeGen removeNativeCodeFrom: (self class>>#stub).
	].
	 
	self assert: (self class>>#stub) hasNativeCode not.
! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 3/20/2011 04:05'!
testPlatformId

	"sometimes i forget to set platform ID, when building plugin"
	
	self assert: NativeBoost platformId ~= 0! !

!NBCoreTests methodsFor: 'testing' stamp: 'IgorStasenko 5/28/2012 07:00'!
testRecursionDetection

	| result |
	result := false.
	
	NBRecursionDetect in: #abc during: [
		result := (NBRecursionDetect signalForMethod: #abc ) 
			].

	self assert: result == true.
	
	result := (NBRecursionDetect signalForMethod: #abc ).
	self assert: result == false.

! !

TestCase subclass: #NBExternalArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Tests'!

!NBExternalArrayTest methodsFor: 'misc' stamp: 'IgorStasenko 12/7/2012 16:06'!
apiClass
	^ NBExternalArray ! !

!NBExternalArrayTest methodsFor: 'testing - class protocols' stamp: 'IgorStasenko 12/7/2012 01:22'!
testAccessors

	"make sure a generated class has accessors installed "
	| cls m_at m_atput |
	
	cls := self apiClass ofType: 'int32' .
	
	self assert: (cls methodDict includesKey: #at: ).
	self assert: (cls methodDict includesKey: #at:put: ).
	
	m_at := cls compiledMethodAt: #at: .
	m_atput  := cls compiledMethodAt: #at:put: .

	"make sure they are properly installed"	
	self assert: m_at methodClass == cls.
	self assert: m_atput methodClass == cls.

	"make sure they are not same as in superclass "
	
	self assert: m_at ~~ (self apiClass compiledMethodAt: #at: ).
	self assert: m_atput ~~ (self apiClass compiledMethodAt: #at:put: ).
! !

!NBExternalArrayTest methodsFor: 'testing - class protocols' stamp: 'IgorStasenko 12/7/2012 02:22'!
testAnonymousClassCreation

	| cls |
	
	cls := self apiClass ofType: 'int32' .
	
	"should get an anonymous subclass" 
	self assert: (cls inheritsFrom: self apiClass).
	
	".. with properly initialized values" 
	self assert: cls elementType equals: 'int32'.
	self assert: cls elementSize = 4 .
	
	" and, of course, they should not be the same object" 
	self assert: cls ~~ self apiClass.
	! !

!NBExternalArrayTest methodsFor: 'testing - instances' stamp: 'IgorStasenko 12/7/2012 02:22'!
testBasicProtocol

	| cls array |
	
	cls := self apiClass ofType: 'int32' .
		
	array := cls new: 10.
	
	self assert: array size equals: 10.
	
	"instantiating with #new: should create an array in object memory "
	self assert: array isExternal equals: false.
	
	self assert: (array at: 1 put: 42) equals: 42.
	self assert: (array at: 1) equals: 42.
	
	self assert: (array at: 10 put: 420) equals: 420.
	self assert: (array at: 10) = 420.
	
	! !

!NBExternalArrayTest methodsFor: 'testing - instances' stamp: 'IgorStasenko 12/7/2012 02:45'!
testExternalArray

	| cls array |
	
	cls := self apiClass ofType: 'int32' .
		
	[ array := cls externalNew: 10.
	
	self assert: array size equals: 10.
	
	"instantiating with #externalNew: should create an array in external memory "
	self assert: array isExternal equals: true.
	
	self assert: (array at: 1 put: 42) equals: 42.
	self assert: (array at: 1) equals: 42.
	
	self assert: (array at: 10 put: 420) equals: 420.
	self assert: (array at: 10) = 420.
	] ensure: [ array free ] 
	! !

!NBExternalArrayTest methodsFor: 'testing - instances' stamp: 'IgorStasenko 12/7/2012 02:44'!
testExternalCopy

	| cls array copy |
	
	cls := self apiClass ofType: 'int32' .
		
	[
		array := cls externalNew: 10.
		array at: 1 put: 2.
		array at: 2 put: 3.
		copy := array copy.
	
		"#copy of external array should create a copy in object memory heap " 
		self assert: copy isExternal equals: false.
		
		"and , of course, copies should be equal "
		self assert: array = copy.	
	] ensure: [ array free ] 
	! !

TestCase subclass: #NBFFICallbackTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Tests'!

!NBFFICallbackTests class methodsFor: 'failures' stamp: 'MarcusDenker 2/20/2013 08:57'!
expectedFailures
	^Smalltalk os isWin32
		ifTrue: [#(testCBGeneratedCode testCallbackCounter testQSortCallbackST testSTCallbackInstalled)] 
		ifFalse: [#()]! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/26/2010 05:38'!
benchQSort

	| bytes memBytes callback callback2 times |
	
	bytes := #[ 2 5 3 10 39 4 80 203 94 215 30 60 80 20 1 4 0 ].
	memBytes := NativeBoost allocate: bytes size.
	
	callback := self createNativeCallback.
	callback2 := NBQSortCallback on: [:a :b | (a byteAt: 0) - (b byteAt: 0) ].

	[ 
		callback install.
		
		times := { 
			[ bytes copy sort ].
	  		[ self primNativeQSort: bytes copy compare: callback address ].
			[ NativeBoost memCopy: bytes to:  memBytes size: bytes size. 
			  self primStQSort: memBytes len: bytes size compare: callback2 ].
		}
		collect: [:block |
			[ 100000 timesRepeat: block ] timeToRun ].

	] ensure:  [ callback uninstall. NativeBoost free: memBytes ].

	^ times

! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:26'!
checkCallback: arr1 with: arr2 compare: nativeCallback

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	

	^ self nbCallout function: #(long  (NBExternalAddress nativeCallback, byte* arr1, byte* arr2 ))
		emit: [:gen |
			gen asm pop: EAX;
				call: EAX
			] ! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:26'!
checkCallbackAddress:  nativeCallbackAddr

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	

	^ self nbCallout function: #(ulong  (NBExternalAddress nativeCallbackAddr))
		emit: [:gen | 	gen asm pop: EAX ] 
"			options: #( - optAllowByteArraysPtr +optAllowExternalAddressPtr  ) "! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:26'!
checkEmitFetchClass
"
	checker for fetching the class code emitting
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	

	^ self nbCallout
		function: #(oop  ())
		emit: [:gen |
			gen emitFetchClass: NBExternalAddress
			]! !

!NBFFICallbackTests methodsFor: 'language-side callback' stamp: 'IgorStasenko 11/24/2012 16:26'!
checkSTCallbackAddress:  callback

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	

	^ self nbCallout 
		function: #(void *  (NBQSortCallback  callback))
		emit: [:gen | 	gen asm pop: EAX ] 
! !

!NBFFICallbackTests methodsFor: 'native callbacks' stamp: 'Igor.Stasenko 9/26/2010 05:36'!
createNativeCallback
	"
	The routine must compare the elements, then return one of the following values:
	< 0 elem1 less than elem2 
	0 elem1 equivalent to elem2 
	> 0 elem1 greater than elem2 
	"
	^ NBNativeFunctionGen 
		cdecl: #( int (byte* a, byte * b) )
		emit: [:gen | | asm |
			asm := gen asm.

			asm 
				mov: (gen arg: #b) to: EAX;
				mov: EAX ptr8 to: CL;
				mov: (gen arg: #a) to: EAX;
				mov: EAX ptr8 to: AL;
				sub: AL with: CL;
				movsx: EAX with: AL  "sign-extend the result"
		]
! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/5/2010 16:55'!
dummyMethod: aParam

	^ aParam! !

!NBFFICallbackTests methodsFor: 'qsort callouts' stamp: 'IgorStasenko 11/24/2012 16:27'!
primNativeQSort: base compare: nativeCallback
"Here, the base must be a ByteArray instance 
	num, the number of elements in it
	width = 4

Call qsort function:	
	void qsort(
	   void *base, - array ptr
	   size_t num,  - number of elements
	   size_t width,  - size of element
	   int (__cdecl *compare )(const void *, const void *) 
	);

	"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #(void qsort (byte* base, NBByteArraySize base, 1, NBExternalAddress nativeCallback))
		module: NativeBoost CLibrary
! !

!NBFFICallbackTests methodsFor: 'qsort callouts' stamp: 'IgorStasenko 11/24/2012 16:27'!
primStQSort: base len: size compare: qsortCallback

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		options: #( optMayGC );
		function: #(void qsort (NBExternalAddress base, ulong size, 1, NBQSortCallback qsortCallback))
		module: NativeBoost CLibrary! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:28'!
readByte: array

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		function: #(byte (byte * array))
		emit: [:gen |
			gen asm pop: EAX;
				mov: EAX ptr8 to: AL
			] ! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:28'!
readByte: array at: index

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		function: #(byte (byte * array, ulong index))
		emit: [:gen |
			gen asm pop: EAX;
				pop: ECX;
				add: EAX with: ECX;
				mov: EAX ptr8 to: AL
			] ! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/16/2012 19:35'!
testCBGeneratedCode
	
	| addr trunk |

	
	addr := NBQSortCallback callbackEnterAddress asUnsignedLong.
	trunk := NBQSortCallback trunkCode.
	
	self assert: (trunk bytes unsignedLongAt: 1+ (trunk offsetAt: #cbEnterAddress) bigEndian: false) = addr.
	
	
	! !

!NBFFICallbackTests methodsFor: 'language-side callback' stamp: 'IgorStasenko 11/24/2012 15:42'!
testCallbackCounter

	| callback orig bytes result ctr |
	
	"There was a bug in callback code, which crashed VM
	due to override of callgate saved method oop and return address,
	and GC, happened during callback"
	
 
	orig := #[ 2 5 55 23 67 23 ] copy.
	bytes := NativeBoost allocate: orig size.
	
	NativeBoost memCopy: orig to: bytes  size: orig size.

	ctr := 0.
	callback := NBQSortCallback on: [:a :b |

		NativeBoost insideCallback ifTrue: [ ctr := ctr+ 1].  "this involves using callgate" 
		Smalltalk garbageCollect. "this involves GC"
		 (a byteAt: 0) - (b byteAt: 0) ].
	
	self primStQSort: bytes len: orig size compare: callback.

	result := ByteArray new: orig size.
	NativeBoost memCopy: bytes to: result size: orig size.
	NativeBoost free: bytes.

	self assert: (ctr > 0).		
	self assert: (orig sort = result)



! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/5/2010 17:00'!
testCreateContext

	| context |
	
	context := 
		MethodContext 
			sender: nil
			receiver: 1
			method: (self class compiledMethodAt: #dummyMethod: )
			arguments: #( 55 ).
			
		
	^ context! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/4/2010 00:14'!
testEmitFetchClass

   self assert: (self checkEmitFetchClass ==  NBExternalAddress)! !

!NBFFICallbackTests methodsFor: 'native callbacks' stamp: 'Igor.Stasenko 9/26/2010 05:38'!
testInstallCallback

	| callback |
	
	callback := self createNativeCallback.

	callback install.
	self assert:(callback address notNil).
	callback uninstall.! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/14/2010 01:03'!
testMemCopy

	| mem bytes |


	bytes := #[ 1 2 3 4 5 6 7 8 9 10 ].
	
	mem := NativeBoost allocate: bytes size.
	
	[
	NativeBoost memCopy: bytes to: mem size: bytes size.
	
	1 to: bytes size do: [:i |
		self assert: (bytes at:i) = (mem byteAt: i-1)
		].
	] ensure: [ NativeBoost free: mem ]! !

!NBFFICallbackTests methodsFor: 'native callbacks' stamp: 'sig 3/30/2012 14:55'!
testNativeCallback

	| orig bytes callback |
	
	orig := #[ 2 5 3 10 39 4 80 ] copy.
	bytes := orig copy.
	
	callback := self createNativeCallback.
	
	[ 
		callback install.
		self primNativeQSort: bytes compare: callback address.
	] ensure:  [ callback uninstall ].

	self assert: (orig sort = bytes)


! !

!NBFFICallbackTests methodsFor: 'language-side callback' stamp: 'IgorStasenko 9/16/2012 19:33'!
testQSortCallbackST
	
	| callback orig bytes result |
	
	orig := #[ 2 5 3 10 39 4 80 ] copy.
	bytes := NativeBoost allocate: orig size.
	
	NativeBoost memCopy: orig to: bytes  size: orig size.

	callback := NBQSortCallback on: [:a :b | (a byteAt: 0) - (b byteAt: 0) ].
	
	self primStQSort: bytes len: orig size compare: callback.

	result := ByteArray new: orig size.
	NativeBoost memCopy: bytes to: result size: orig size.
	NativeBoost free: bytes.
		
	self assert: (orig sort = result)



! !

!NBFFICallbackTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/4/2010 00:33'!
testReadByte

	| arr |
	
	arr := #(240 2 3 4 ) asByteArray.
	
	self assert: (self readByte: arr) == 240! !

!NBFFICallbackTests methodsFor: 'language-side callback' stamp: 'IgorStasenko 11/24/2012 15:29'!
testSTCallbackInstalled

	| callback trunk index |

	callback := NBQSortCallback on: [:x :y | ]. 
	trunk := callback trunk.
	index := callback index.
	
	self assert: ((NativeBoost extraRootsRegistry at: #callbacks) at: index +1) == callback.
	
	self assert: (self checkSTCallbackAddress:  callback) = trunk

	! !

!NBFFICallbackTests methodsFor: 'native callbacks' stamp: 'Igor.Stasenko 9/26/2010 05:38'!
testcallbackAddress

	| callback addr1 addr2 |

	callback := self createNativeCallback.
	
	[ 
		callback install.
		addr1 := callback address value.
		addr2 := self checkCallbackAddress: callback address.
	] ensure:  [ callback uninstall ].

	self assert: (addr1 = addr2)! !

TestCase subclass: #NBObjectFormat32Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Tests'!

!NBObjectFormat32Tests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:23'!
getFloatPtrOffset: aFloat
	"return the difference between float oop and pointer to its stored floating-point value ,
	must be base header size"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #( ulong (oop aFloat, NBFloatPtr aFloat))
		emit: [:gen | | asm |
			asm := gen asm.
			asm pop: asm ECX. "oop"
			asm pop: asm EAX. "float ptr"
			asm sub: asm EAX with: asm ECX
		]! !

!NBObjectFormat32Tests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:23'!
pushDouble: aFloat

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #( double (double aFloat))
		emit: [:gen |
			| asm |
			asm := gen asm.
			asm fld: asm ESP ptr64		
		]! !

!NBObjectFormat32Tests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:24'!
pushFloat: aFloat

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		function: #( double (float aFloat))
		emit: [:gen |
			| asm |
			asm := gen asm.
			asm fld: asm ESP ptr32		
		]! !

!NBObjectFormat32Tests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/23/2011 10:46'!
testCompactFloats

	| idx format |
	format := NBObjectFormat32 new.
	idx := Smalltalk compactClassesArray indexOf: Float ifAbsent: [ ^ nil ].
	idx := idx bitShift: format compactClassIndexShift.

	NativeBoost enableNativeCode.
	Float allInstances do: [:each |
		| oopIdx |
		oopIdx := (NBObjectFormat32 headerOf: each) bitAnd: format compactClassMask.
		self assert: (oopIdx = idx) ]! !

!NBObjectFormat32Tests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 14:21'!
testPushingFloatPointers

	self assert: (self getFloatPtrOffset: 10.0) =  NBObjectFormat current baseHeaderSize.
! !

!NBObjectFormat32Tests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/20/2010 09:19'!
testPushingFloats

	self assert: (self pushFloat: 100.0) = 100.0.
	self assert: (self pushDouble: 100.0) = 100.0.! !

TestCase subclass: #NativeCodeTests
	instanceVariableNames: 'did'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Tests'!

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/5/2011 08:22'!
createMoveTestCode

	^ NBFFICallout new
		anonSpec: #( int ());
		cdecl;
		generate: [:gen :proxy :asm |
			| methodOop |
			
			methodOop := gen reserveTemp.
			
			proxy primitiveMethod.
			asm mov: asm EAX to: methodOop.
			
			"call fullGC to trigger memory compaction"
			proxy fullGC.
			
			"return the difference between old primitiveMethod oop value and new one"
			proxy primitiveMethod.
			asm sub: asm EAX with: methodOop.

	].! !

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 10:56'!
install: nativeCode into: method

	| trailer  newMethod |
	trailer := CompiledMethodTrailer new.

	trailer nativeCode: nativeCode platformId: NativeBoost platformId sourcePointer: method trailer sourcePointer.
	newMethod := method copyWithTrailerBytes: trailer.
	
	method methodClass methodDict at: method selector put: newMethod.
	
! !

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/11/2010 18:21'!
movableStub
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	^ 999! !

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/27/2012 18:20'!
testArgumentOffsets

	"cdecl arguments placed in reverse order,
	
	push c;
	push b;
	push a..
	
	so, c is most closer to stack frame and having smallest offset.
	"
	NBNativeFunctionGen 
		cdecl: #( int (byte a, void * b, double c) )
		emit: [:gen |
			| arg |

			arg := gen arg: #a.
			self assert: (arg isMem).
			self assert: (arg displacement value = 8).

			arg := gen arg: #b.
			self assert: (arg isMem).
			self assert: (arg displacement value = 12).

			arg := gen arg: #c.
			self assert: (arg isMem).
			self assert: (arg displacement value = 16).
			
		]! !

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/5/2011 08:24'!
testMovableStuff
	"test that if native code calls a VM function which triggers
	a full gc and relocates a native code, it will survive the move,
	
	a native code should return a difference between old and new primitive method,
	in case if its moved, the difference will be nonzero"
	
	| code |

	code := self createMoveTestCode.
	" we should not crash here ;) "
	^ (1 to: 10) collect: 
		[:each| 
			Array new: (Random new nextInt: 100). 
			self install: code into: (self class methodDict at: #movableStub).
		  
			self movableStub  
		]
	
	! !

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 20:03'!
testProxyFunctions

	| functions |
	
	functions := NBInterpreterProxy functions.
	functions valuesDo: [:fn |
		self assert: (NBInterpreterProxy canUnderstand: fn selector ).
	]! !

!NativeCodeTests methodsFor: 'as yet unclassified' stamp: 'GuyHylton 9/12/2012 13:53'!
testStructAccess

	| struct |
	
	NBTestStructure rebuildFieldAccessors.
	
	struct := NBTestStructure new.
	
	struct byte: 10.
	struct short: -20.
	struct long: 100.
	struct float: 1.0.
	struct double: 2.0.
	struct int64: 123456789101112.
	
	self assert: (struct byte = 10).
	self assert: (struct short = -20).	
	self assert: (struct long = 100).	
	self assert: (struct float = 1.0).	
	self assert: (struct double = 2.0).	
	self assert: (struct int64 = 123456789101112).	
	! !

NBExternalHeapManager subclass: #NBMockExternalHeapManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBMockExternalHeapManager methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:20'!
primAllocatePage: numBytes

	^ 0! !

!NBMockExternalHeapManager methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:21'!
primFreePage: aMemoryPage

	^ 0! !

Object subclass: #NBMockExternalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

NBExternalObject subclass: #NBMockExternalObject
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'!

!NBMockExternalObject class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/24/2012 17:18'!
finalizeResourceData: object

	object value! !

!NBMockExternalObject methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/24/2012 17:05'!
data: anObject
	data := anObject! !

!NBMockExternalObject methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/24/2012 17:05'!
resourceData
	^ data! !
